diff --git a/logview/plugins/baseview.c b/logview/plugins/baseview.c
new file mode 100644
index 0000000..c1abfc4
--- /dev/null
+++ b/logview/plugins/baseview.c
@@ -0,0 +1,289 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+ 
+#include <glib.h>
+#include <stdio.h>
+#include <signal.h>
+#include <glib.h>
+#include "logview-plugin.h"
+#include "logview-iface-view.h"
+#include "logview-debug.h"
+#include "logview-log.h"
+#include "misc.h"
+
+
+#define PLUGIN_BASEVIEW(obj) \
+	(G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_BASEVIEW, Baseview))
+#define PLUGIN_BASEVIEW_CLASS(klass) \
+	(G_TYPE_CHECK_CLASS_CAST ((klass), PLUGIN_TYPE_BASEVIEW, BaseviewClass))
+#define BASEVIEW_IS_PLUGIN(obj) \
+	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_BASEVIEW))
+#define BASEVIEW_IS_PLUGIN_CLASS(klass) \
+	(G_TYPE_CHECK_CLASS_TYPE ((klass), PLUGIN_TYPE_BASEVIEW))
+#define PLUGIN_BASEVIEW_GET_CLASS(obj) \
+	(G_TYPE_INSTANCE_GET_CLASS ((obj), PLUGIN_TYPE_BASEVIEW, BaseviewClass))
+
+#undef PLUGIN_PRIO
+#define PLUGIN_PRIO	PLUG_PRIO_BASE
+#undef PLUGIN_DESC
+#define PLUGIN_DESC	"Group by date and try to convert to UTF-8"
+
+typedef struct _Baseview Baseview;
+typedef struct _BaseviewClass BaseviewClass;
+
+struct _Baseview {
+	LogviewPlugin parent;
+};
+
+struct _BaseviewClass {
+	LogviewPluginClass parent;
+};
+
+
+/* class implement */
+static void iface_init (gpointer g_iface, gpointer iface_data);
+static void view_init (gpointer g_iface, gpointer iface_data);
+
+static void
+baseview_class_init (gpointer g_class, gpointer g_class_data)
+{
+	LV_MARK;
+}
+
+static void
+baseview_instance_init (GTypeInstance *instance, gpointer g_class_data)
+{
+	LV_MARK;
+}
+
+static GType
+baseview_get_type (GTypeModule* module)
+{
+	static GType type = 0;
+	LV_MARK;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (BaseviewClass),
+			NULL,   /* base_init */
+			NULL,   /* base_finalize */
+			baseview_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			sizeof (Baseview),
+			0,      /* n_preallocs */
+			baseview_instance_init    /* instance_init */
+		};
+		static const GInterfaceInfo iface_info = {
+			iface_init,	/* interface_init */
+			NULL,		/* interface_finalize */
+			NULL		/* interface_data */
+		};
+		static const GInterfaceInfo view_info = {
+			view_init,	/* interface_init */
+			NULL,		/* interface_finalize */
+			NULL		/* interface_data */
+		};
+		type = g_type_module_register_type (module,
+						    LOGVIEW_TYPE_PLUGIN,
+						    "BaseviewType",
+						    &info,
+						    0);
+		g_type_module_add_interface (module, type, LOGVIEW_TYPE_IFACE,
+			&iface_info);
+		g_type_module_add_interface (module, type, LOGVIEW_TYPE_IFACE_VIEW,
+			&view_info);
+	}
+	return type;
+}
+
+/* interfaces */
+static gboolean
+can_handle(Baseview *self, Log *log)
+{
+	LV_MARK;
+	return TRUE;
+}
+
+static gint 
+days_compare (gconstpointer a, gconstpointer b)
+{
+	const Day *day1 = a, *day2 = b;
+	return (g_date_compare (day1->date, day2->date));
+}
+
+/* log_read_dates
+   Read all dates which have a log entry to create calendar.
+   All dates are given with respect to the 1/1/1970
+   and are then corrected to the correct year once we
+   reach the end.
+*/
+
+static GSList *
+baseview_read_dates (LogviewIView *self, gchar **buffer_lines, time_t current)
+{
+	int offsetyear = 0, current_year;
+	GSList *days = NULL, *days_copy;
+	GDate *date, *newdate;
+	struct tm *tmptm;
+	gchar *date_string;
+	Day *day;
+	gboolean done = FALSE;
+	int i, n, rangemin, rangemax;
+
+	if (buffer_lines == NULL)
+		return NULL;
+
+	n = g_strv_length (buffer_lines);
+	for (i=0; buffer_lines[i] == NULL && i < n; i++);
+	if (i == n)
+		return NULL;
+
+	tmptm = localtime (&current);
+	current_year = tmptm->tm_year + 1900;
+
+	/* Start building the list */
+	/* Scanning each line to see if the date changed is too slow,
+	   so we proceed in a recursive fashion */
+
+	date = string_get_date (buffer_lines[i]);
+	if ((date==NULL)|| !g_date_valid (date)) {
+		return NULL;
+	}
+
+	g_date_set_year (date, current_year);
+	day = g_new0 (Day, 1);
+	days = g_slist_append (days, day);
+
+	day->date = date;
+	day->first_line = i;
+	day->last_line = -1;
+	date_string = get_date_string (buffer_lines[i]);
+
+	rangemin = 0;
+	rangemax = n-1;
+
+	while (!done) {
+	   
+		i = n-1;
+		while (day->last_line < 0) {
+
+			if (g_str_has_prefix (buffer_lines[i], date_string)) {
+				if (i == (n-1)) {
+					day->last_line = i;
+					done = TRUE;
+					break;
+				} else {
+					if (!g_str_has_prefix (buffer_lines[i+1], date_string)) {
+						day->last_line = i;
+						break;
+					} else {
+						rangemin = i;
+						i = (int) ( ((float) i + (float) rangemax)/2.);
+					}
+				}
+			} else {
+				rangemax = i;
+				i = (int) (((float) rangemin + (float) i)/2.);				
+			}
+
+		}
+	   
+		g_free (date_string);
+
+		if (!done) {
+			/* We need to find the first line now that has a date
+			   Logs can have some messages without dates ... */
+			newdate = NULL;
+			while (newdate == NULL && !done && i < n) {
+				i++;
+				date_string = get_date_string (buffer_lines[i]);
+				if (date_string == NULL)
+					continue;
+				g_assert (newdate == NULL);
+				newdate = string_get_date (buffer_lines[i]);
+		   
+				if (newdate == NULL && i==n-1)
+					done = TRUE;
+			}
+
+			day->last_line = i-1;
+
+			/* Append a day to the list */	
+			if (newdate) {
+				g_date_set_year (newdate, current_year + offsetyear);	
+				if (g_date_compare (newdate, date) < 1) {
+					offsetyear++; /* newdate is next year */
+					g_date_add_years (newdate, 1);
+				}
+		   
+				date = newdate;
+				day = g_new0 (Day, 1);
+				days = g_slist_append (days, day);
+		   
+				day->date = date;
+				day->first_line = i;
+				day->last_line = -1;
+				rangemin = i;
+				rangemax = n;
+			}
+		}
+	}
+
+	/* Correct years now. We assume that the last date on the log
+	   is the date last accessed */
+
+	for (days_copy = days; days_copy != NULL; days_copy = g_slist_next (days_copy)) {	   
+		day = days_copy -> data;
+		g_date_subtract_years (day->date, offsetyear);
+	}
+   
+	/* Sort the days in chronological order */
+	days = g_slist_sort (days, days_compare);
+
+	return (days);
+}
+
+static GSList*
+group_lines (LogviewIView *self, const gchar **lines)
+{
+	LV_MARK;
+	return baseview_read_dates (self, (gchar **)lines, time (NULL));
+}
+
+static void
+iface_init (gpointer g_iface, gpointer iface_data)
+{
+	LogviewInterface *iface = (LogviewInterface*)g_iface;
+	LV_MARK;
+	iface->can_handle = (gboolean (*) (LogviewIFace*, Log*)) can_handle;
+}
+
+static gchar*
+to_utf8 (LogviewIView *self, gchar *str)
+{
+	char *out;
+	if (g_utf8_validate (str, -1, NULL))
+		out = str;
+	else {
+		if ((out = g_locale_to_utf8 (str, -1, NULL, NULL, NULL)) != NULL)
+			g_free (str);
+		else
+			out = str;
+	}
+	return out;
+}
+
+static void
+view_init (gpointer g_iface, gpointer iface_data)
+{
+	LogviewIFaceView *self = (LogviewIFaceView*)g_iface;
+	LV_MARK;
+	self->group_lines = (GSList* (*) (LogviewIView*, const gchar**)) group_lines;
+	self->to_utf8 = (gchar* (*) (LogviewIView*, gchar*, gssize)) to_utf8;
+}
+
+LOGVIEW_INIT_PLUGIN (baseview_get_type)
+
diff --git a/logview/plugins/grablogs.c b/logview/plugins/grablogs.c
new file mode 100644
index 0000000..efcf1d6
--- /dev/null
+++ b/logview/plugins/grablogs.c
@@ -0,0 +1,496 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+ 
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <string.h>
+#include <glib.h>
+#include <stdio.h>
+#include <signal.h>
+#include <glib.h>
+#include <locale.h>
+#include "logview-plugin.h"
+#include "logview-iface-collector.h"
+#include "logview-debug.h"
+#include "logview-log.h"
+#include "misc.h"
+
+#define PLUGIN_GRABLOGS(obj) \
+	(G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_GRABLOGS, PluginGrabLogs))
+#define PLUGIN_GRABLOGS_CLASS(klass) \
+	(G_TYPE_CHECK_CLASS_CAST ((klass), PLUGIN_TYPE_GRABLOGS, PluginGrabLogsClass))
+#define GRABLOGS_IS_PLUGIN(obj) \
+	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_GRABLOGS))
+#define GRABLOGS_IS_PLUGIN_CLASS(klass) \
+	(G_TYPE_CHECK_CLASS_TYPE ((klass), PLUGIN_TYPE_GRABLOGS))
+#define PLUGIN_GRABLOGS_GET_CLASS(obj) \
+	(G_TYPE_INSTANCE_GET_CLASS ((obj), PLUGIN_TYPE_GRABLOGS, PluginGrabLogsClass))
+
+#undef PLUGIN_PRIO
+#define PLUGIN_PRIO	PLUG_PRIO_BASE
+#undef PLUGIN_DESC
+#define PLUGIN_DESC	"For colloct log files from shell commands"
+
+#ifdef ON_SUN_OS
+#define FILE_CMD "file"
+#else
+#define FILE_CMD "file"
+#endif
+#define GRABLOGS_CONF	"grablogs.conf"
+#define CAT_CMD		"[commands]"
+#define CAT_LOG		"[logs]"
+#define CAT_CONF	"[configs]"
+
+
+typedef GSList* (*Parse_All) (FILE*);
+typedef GSList* (*Parse_Line) (FILE*, Parse_All);
+typedef struct _PluginGrabLogs PluginGrabLogs;
+typedef struct _PluginGrabLogsClass PluginGrabLogsClass;
+
+struct _PluginGrabLogs {
+	LogviewPlugin parent;
+};
+
+struct _PluginGrabLogsClass {
+	LogviewPluginClass parent;
+};
+
+/* class implement */
+static void iface_init (gpointer g_iface, gpointer iface_data);
+static void collector_init (gpointer g_iface, gpointer iface_data);
+
+static struct sigaction old_sa;
+static gchar* category;
+
+static void
+grablogs_class_init (gpointer g_class, gpointer g_class_data)
+{
+	LV_MARK;
+}
+
+static void
+grablogs_instance_init (GTypeInstance *instance, gpointer g_class_data)
+{
+	LV_MARK;
+}
+
+static GType
+grablogs_get_type (GTypeModule* module)
+{
+	static GType type = 0;
+	LV_MARK;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (PluginGrabLogsClass),
+			NULL,   /* base_init */
+			NULL,   /* base_finalize */
+			grablogs_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			sizeof (PluginGrabLogs),
+			0,      /* n_preallocs */
+			grablogs_instance_init    /* instance_init */
+		};
+		static const GInterfaceInfo iface_info = {
+			iface_init,	/* interface_init */
+			NULL,		/* interface_finalize */
+			NULL		/* interface_data */
+		};
+		static const GInterfaceInfo collector_info = {
+			collector_init,	/* interface_init */
+			NULL,		/* interface_finalize */
+			NULL		/* interface_data */
+		};
+		type = g_type_module_register_type (module,
+						    LOGVIEW_TYPE_PLUGIN,
+						    "GrablogsType",
+						    &info,
+						    0);
+		g_type_module_add_interface (module, type, LOGVIEW_TYPE_IFACE,
+			&iface_info);
+		g_type_module_add_interface (module, type, LOGVIEW_TYPE_IFACE_COLLECTOR,
+			&collector_info);
+	}
+	return type;
+}
+
+static GSList*
+get_logs (const gchar* logcfg, Parse_All cp)
+{
+	GSList* loglist = NULL;
+	FILE* handle;
+	int (*lclose) (FILE*) = NULL;
+	
+	LV_MARK;
+	/*
+	 * lines in [command] will be run in popen
+	 */
+	if (category && g_ascii_strcasecmp(g_strstrip(category),
+					   CAT_CMD) == 0) {
+		LV_INFO ("[grablogs-PIPE-open] %s", logcfg);
+		handle = security_popen (logcfg, "r");
+		lclose = security_pclose;
+	}
+	else if (local_file_exist (logcfg)
+		 && local_file_can_executed (logcfg)) {
+		LV_INFO ("[grablogs-FILE-open] %s", logcfg);
+		handle = fopen (logcfg, "r");
+		lclose = fclose;
+	}
+	else
+		goto get_logs_err;
+
+	if (handle != NULL) {
+		LV_INFO ("[grablogs-open] %s", logcfg);
+		loglist = cp (handle);
+		if (lclose (handle) == -1)
+			goto get_logs_err;
+		LV_INFO ("[grablogs-close] %s", logcfg);
+	}
+	else {
+get_logs_err:
+		LV_INFO_EE ("[grablogs handles]: \"%s\", msg: %s",
+			    logcfg, error_system_string ());
+		return NULL;
+	}
+	return loglist;
+}
+
+static gchar*
+get_line (FILE *handle)
+{
+	glong inc = BUFSIZ, size = inc;
+	glong p = -1;
+	gchar *buf = (gchar *) g_malloc (size * sizeof (gchar));
+	g_assert (handle);
+	g_assert (buf);
+	do {
+		g_assert (p < size);
+		if (++p == size) {
+			size += inc;
+			buf = (gchar *) g_realloc (buf, size * sizeof(gchar));
+			g_assert (buf);
+		}
+		buf[p] = (gchar)getc (handle);
+	} while (buf[p] != '\n' && buf[p] != EOF);
+	if (buf[p] != EOF) {
+		buf[p] = '\0';
+	} else if (feof (handle) == 0 && p > 0) {
+		buf[p] = '\0';
+	} else if (feof (handle) != 0) {
+		LV_INFO_EE ("get_line error: %s", error_system_string());
+		g_free (buf);
+		buf = NULL;
+	} else {
+		g_free (buf);
+		buf = NULL;
+	}
+	LV_ERR ("get_line %s", buf? buf:"EOFed");
+	return buf;
+}
+
+/* one log per line */
+static GSList*
+cp_logline (FILE *handle)
+{
+	gchar *buf;
+	GSList *logfiles = NULL;
+	LV_MARK;
+	while ((buf = get_line(handle)) != NULL) {
+		if (g_str_has_prefix (g_strchug (buf), "#")) {
+			g_free (buf);
+			continue;
+		}
+		if (g_str_has_prefix(g_strstrip(buf), "[")) {
+			g_free (category);
+			category = buf;
+			break;
+		}
+		if (strlen (buf) != 0)
+			logfiles = g_slist_append (logfiles, g_strdup (buf));
+		g_free (buf);
+	}
+	return logfiles;
+}
+
+
+static GSList*
+cp_logconf (FILE *handle)
+{
+	gchar *buf, *p;
+	GSList *logfiles = NULL;
+	LV_MARK;
+	while ((buf = get_line(handle)) != NULL) {
+		gchar **list;
+		gint i;
+		for (p = buf; g_ascii_isspace(*p); ++p);
+		if (*p == '\0' || *p == '#' || *p == '\n') {
+			g_free (buf);
+			continue;
+		}
+		list = g_strsplit_set (p, ", -\t()\n'`", 0);
+		for (i = 0; list[i]; ++i) {
+			if (*list[i] == '/' &&
+			    g_slist_find_custom(logfiles, list[i],
+						(GCompareFunc)g_ascii_strcasecmp) == NULL) {
+				logfiles = g_slist_append (logfiles,
+							   g_strdup(list[i]));
+			}
+		}
+		g_strfreev(list);
+		g_free (buf);
+	}
+	return logfiles;
+}
+
+/* one shell or command per line
+ * run each line
+ * one log per line of output
+ */
+static GSList*
+cp_shell_per_line (FILE *handle)
+{
+	gchar *buf = NULL;
+	GSList *all_logs = NULL;
+	LV_MARK;
+	while ((buf = get_line(handle)) != NULL) {
+		if (g_str_has_prefix (g_strchug (buf), "#")) {
+			g_free (buf);
+			continue;
+		}
+		if (g_str_has_prefix(g_strchug (buf), "[")) {
+			g_free (category);
+			category = buf;
+			break;
+		}
+		if (strlen (buf) != 0) {
+			GSList *idx;
+			GSList *logfiles = NULL;
+			logfiles = get_logs (buf, cp_logline);
+			for (idx = logfiles; idx; idx=g_slist_next(idx)) {
+				if (g_slist_find_custom (all_logs, idx->data,
+							 (GCompareFunc)g_ascii_strcasecmp)
+				    == NULL) {
+					all_logs = g_slist_append (all_logs,
+								   idx->data);
+				}
+				else
+					g_free (idx->data);
+			}
+			if (logfiles)
+				g_slist_free (logfiles);
+		}
+		g_free (buf);
+	}
+	return all_logs;
+}
+
+static GSList*
+cp_conf_per_line (FILE *handle)
+{
+	gchar *buf = NULL;
+	GSList *all_logs = NULL;
+	LV_MARK;
+	while ((buf = get_line(handle)) != NULL) {
+		if (g_str_has_prefix (g_strchug (buf), "#")) {
+			g_free (buf);
+			continue;
+		}
+		if (g_str_has_prefix(g_strchug (buf), "[")) {
+			g_free (category);
+			category = buf;
+			break;
+		}
+		if (strlen (buf) != 0) {
+			GSList *idx;
+			GSList *logfiles = NULL;
+			logfiles = get_logs (buf, cp_logconf);
+			for (idx = logfiles; idx; idx=g_slist_next(idx)) {
+				if (g_slist_find_custom (all_logs, idx->data,
+							 (GCompareFunc)g_ascii_strcasecmp)
+				    == NULL) {
+					all_logs = g_slist_append (all_logs,
+								   idx->data);
+				}
+				else
+					g_free (idx->data);
+			}
+			if (logfiles)
+				g_slist_free (logfiles);
+		}
+		g_free (buf);
+	}
+	return all_logs;
+}
+
+static GSList*
+cp_grab_conf (FILE *handle)
+{
+	GSList *all_logs = NULL;
+	LV_MARK;
+
+	/* A line without any categories will be skipped */
+	category = get_line(handle);
+	while (feof (handle) == 0) {
+		if (g_str_has_prefix (g_strchug (category), "#"))
+			goto next_line;
+		if (category) {
+			if (g_ascii_strcasecmp(g_strstrip(category),
+					       CAT_CMD) == 0) {
+				LV_INFO ("grab category %s, enter", category);
+				all_logs = g_slist_concat (all_logs,
+							   cp_shell_per_line (handle));
+			}
+			else if (g_ascii_strcasecmp(g_strstrip(category),
+						    CAT_LOG) == 0) {
+				LV_INFO ("grab category %s, enter", category);
+				all_logs = g_slist_concat (all_logs,
+							   cp_logline (handle));
+			}
+			else if (g_ascii_strcasecmp(g_strstrip(category),
+						    CAT_CONF) == 0) {
+				LV_INFO ("grab category %s, enter", category);
+				all_logs = g_slist_concat (all_logs,
+							   cp_conf_per_line (handle));
+			}
+			else
+				goto next_line;
+		}
+		else {
+next_line:
+			g_free (category);
+			category = get_line(handle);
+		}
+	}
+	g_free (category);
+	return all_logs;
+}
+
+static GSList*
+get_all_logs (PluginGrabLogs *self)
+{
+	GSList *plugin_paths, *i;
+	GSList *all_logs = NULL;
+	LV_MARK;
+
+	plugin_paths = (GSList *) get_plugin_paths ();
+	category = NULL;
+	for (i = plugin_paths; i; i=g_slist_next(i)) {
+		gchar* path = g_build_path (G_DIR_SEPARATOR_S,
+					    i->data, GRABLOGS_CONF, NULL);
+		if (local_file_exist (path)
+		    && local_file_can_executed (path)) {
+			GSList *logfiles, *idx;
+			logfiles = get_logs (path, cp_grab_conf);
+			for (idx = logfiles; idx; idx = g_slist_next(idx)) {
+				if (g_slist_find_custom (all_logs, idx->data,
+							 (GCompareFunc)g_ascii_strcasecmp) == NULL) {
+					all_logs = g_slist_append (all_logs, idx->data);
+					LV_ERR ("add %s", idx->data);
+				}
+				else {
+					LV_ERR ("del %s", idx->data);
+					g_free (idx->data);
+				}
+			}
+			g_slist_free (logfiles);
+			/* break to search the sequent path of GRABLOGS_CONF */
+			g_free (path);
+			break;
+		} else {
+			g_free (path);
+		}
+	}
+	return all_logs;
+}
+
+static void
+config_child_log (Log *log)
+{
+	/* Check for older versions of the log */
+	gchar *log_name = NULL;
+	gint i;
+	g_object_get (G_OBJECT (log), "path", &log_name, NULL);
+	for (i=0; i<OLD_LOG_NUM; i++) {
+		gboolean flag = FALSE;
+		gchar *older_name;
+		Log *child;
+		older_name = g_strdup_printf ("%s.%d", log_name, i);
+		if (local_file_exist (older_name)) {
+			flag = TRUE;
+		} else {
+			g_free (older_name);
+			older_name = g_strdup_printf ("%s.%d.gz", log_name, i);
+			if (local_file_exist (older_name)) {
+				flag = TRUE;
+			}
+		}
+		if (flag) {
+			child = g_object_new (LOGVIEW_TYPE_LOG,
+					      "path", older_name,
+					      "protocol", file_protocol (older_name),
+					      NULL);
+			log_set_child (log, i, child);
+		}
+		g_free (older_name);
+	}
+	g_free (log_name);
+}
+
+static Log*
+config_log_from_path (PluginGrabLogs *self, const gchar *log_path)
+{
+	Log *log;
+	LogProtocol protocol;
+	gchar *utf8_name = NULL;
+	gchar *name;
+	gchar *message;
+
+	protocol = file_protocol (log_path);
+	switch (protocol) {
+	case UNKNOWN_LOG:
+	case PLAIN_LOG:
+	case GZIP_LOG:
+	case PIPE_LOG:
+		log = g_object_new (LOGVIEW_TYPE_LOG,
+				    "path", log_path,
+				    "protocol", protocol,
+				    NULL);
+		config_child_log (log);
+		return log;
+	default:;
+	}
+	utf8_name = locale_to_utf8 (log_path);
+	name = utf8_name ? utf8_name : log_path;
+	/* SUN_BRANDING */
+	message = g_strdup_printf (_("Unknown file type: %d"), protocol);
+	log_error_appendv ("grablogs - %s - %s", name, message);
+	g_free (message);
+	g_free (utf8_name);
+	return NULL;
+}
+
+static void
+iface_init (gpointer g_iface, gpointer iface_data)
+{
+	LogviewInterface *iface = (LogviewInterface*) g_iface;
+	LV_MARK;
+	iface->can_handle = NULL; /* dummy */
+}
+
+static void
+collector_init (gpointer g_iface, gpointer iface_data)
+{
+	LogviewIFaceCollector *iface = (LogviewIFaceCollector*) g_iface;
+	LV_MARK;
+	iface->get_logs = (GSList* (*) (LogviewICollector*)) get_all_logs;
+	iface->config_log_from_path = (Log* (*) (LogviewICollector*, const gchar*))config_log_from_path;
+}
+
+LOGVIEW_INIT_PLUGIN (grablogs_get_type)
+
diff --git a/logview/plugins/grablogs.conf b/logview/plugins/grablogs.conf
new file mode 100644
index 0000000..78841cc
--- /dev/null
+++ b/logview/plugins/grablogs.conf
@@ -0,0 +1,10 @@
+[commands]
+for i in `svcs -aH -o FMRI | grep -v lrc `; do svcprop -p restarter/logfile $i 2>/dev/null || svcprop -q -p restarter/alt_logfile $i 2>/dev/null ; done
+
+[logs]
+/var/adm/messages
+/var/adm/wtmpx
+/var/adm/utmpx
+/var/log/Xorg.0.log
+/var/log/syslog
+
diff --git a/logview/plugins/pipelog.c b/logview/plugins/pipelog.c
new file mode 100644
index 0000000..56de934
--- /dev/null
+++ b/logview/plugins/pipelog.c
@@ -0,0 +1,428 @@
+/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */
+/*
+ * Copyright (C) 2006 Lin Ma <Lin.Ma@sun.com>
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+#include <glib.h>
+#include <gtk/gtk.h>
+#include <glib/gi18n.h>
+#include <strings.h>
+#include <stdlib.h>
+#include <signal.h>
+#include <libgnomevfs/gnome-vfs.h>
+#include "logview-iface-io.h"
+#include "misc.h"
+#include "logview-debug.h"
+#include "logview-log.h"
+#include "logview-plugin.h"
+
+#define PLUGIN_PIPELOG(obj) \
+	(G_TYPE_CHECK_INSTANCE_CAST((obj), PLUGIN_TYPE_PIPELOG, PluginPipelog))
+#define PLUGIN_PIPELOG_CLASS(klass) \
+	(G_TYPE_CHECK_CLASS_CAST((klass), PLUGIN_TYPE_PIPELOG, PluginPipelogClass))
+#define PIPELOG_IS_PLUGIN(obj) \
+	(G_TYPE_CHECK_INSTANCE_TYPE((obj), PLUGIN_TYPE_PIPELOG))
+#define PIPELOG_IS_PLUGIN_CLASS(klass) \
+	(G_TYPE_CHECK_CLASS_TYPE((klass), PLUGIN_TYPE_PIPELOG))
+#define PLUGIN_PIPELOG_GET_CLASS(obj) \
+	(G_TYPE_INSTANCE_GET_CLASS((obj), PLUGIN_TYPE_PIPELOG, PluginPipelogClass))
+
+#undef PLUGIN_DESC
+#define PLUGIN_DESC	"For non-ASCII formatted log files"
+#undef PLUGIN_PRIO
+#define PLUGIN_PRIO (PLUG_PRIO_BASE + 1)
+
+typedef struct _PluginPipelog PluginPipelog;
+typedef struct _PluginPipelogClass PluginPipelogClass;
+
+struct _PluginPipelog {
+	LogviewPlugin parent;
+
+	Log *log;
+
+	gchar *log_name;
+	LogProtocol protocol;
+
+	gchar *pipe;
+	time_t file_time;
+	GnomeVFSFileSize file_size;
+	FILE *file_handle;
+	gchar *pbuffer;
+	gssize psize;
+	gssize poffset;
+};
+
+struct _PluginPipelogClass {
+	LogviewPluginClass parent;
+};
+
+static GObjectClass *parent_class = NULL;
+
+/* default routines for implement the plugin interfaces */
+static void iface_init (gpointer g_iface, gpointer iface_data);
+static void io_init (gpointer g_iface, gpointer iface_data);
+static gboolean plugin_init (PluginPipelog* self);
+static void plugin_destroy (PluginPipelog* self);
+
+/* interfaces */
+static gboolean can_handle(PluginPipelog *self, Log *log);
+static gboolean can_monitor(PluginPipelog *self);
+static gboolean has_updated(PluginPipelog *self);
+static gboolean update(PluginPipelog *self);
+static void logf_extract_filepath (PluginPipelog *self, gchar** dirname, gchar** filename);
+static size_t logf_read (PluginPipelog *self, void* buffer, size_t size);
+static off_t logf_seek (PluginPipelog *self, off_t offset, int whence);
+static off_t logf_tell (PluginPipelog *self);
+static time_t get_modified_time (PluginPipelog* self);
+static off_t get_size (PluginPipelog* self);
+
+/* others */
+static gboolean seek_pipe_log (PluginPipelog* self, const gchar *filename);
+
+#define PIPELOG_CONF	"pipelog.conf"
+
+/* class implement */
+static void
+pipelog_finalize (PluginPipelog *self)
+{
+	g_free (self->log_name);
+}
+
+static void
+pipelog_class_init (gpointer g_class, gpointer g_class_data)
+{
+	LV_MARK;
+	LogviewPluginClass *parent = LOGVIEW_PLUGIN_CLASS (g_class);
+	parent_class = g_type_class_peek_parent (g_class);
+	G_OBJECT_CLASS (g_class)->finalize = (void (*) (GObject*)) pipelog_finalize;
+
+	parent->plugin_init = (gboolean (*) (LogviewPlugin*)) plugin_init;
+	parent->plugin_destroy = (void (*) (LogviewPlugin*)) plugin_destroy;
+}
+
+static void
+pipelog_instance_init (GTypeInstance *instance, gpointer g_class_data)
+{
+	PluginPipelog *self;
+	LV_MARK;
+	self = (PluginPipelog*) instance;
+	self->pipe = NULL;
+	self->pbuffer = NULL;
+	self->psize = 0;
+	self->poffset = 0;
+	self->log_name = NULL;
+}
+
+static GType
+pipelog_get_type (GTypeModule* module)
+{
+	static GType type = 0;
+	LV_MARK;
+	if (type == 0) {
+		static const GTypeInfo info = {
+			/* You fill this structure. */
+			sizeof (PluginPipelogClass),
+			NULL,   /* base_init */
+			NULL,   /* base_finalize */
+			pipelog_class_init,   /* class_init */
+			NULL,   /* class_finalize */
+			NULL,   /* class_data */
+			sizeof (PluginPipelog),
+			0,      /* n_preallocs */
+			pipelog_instance_init    /* instance_init */
+		};
+		static const GInterfaceInfo iface_info = {
+			iface_init,	/* interface_init */
+			NULL,		/* interface_finalize */
+			NULL		/* interface_data */
+		};
+		static const GInterfaceInfo io_info = {
+			io_init,	/* interface_init */
+			NULL,		/* interface_finalize */
+			NULL		/* interface_data */
+		};
+		type = g_type_module_register_type (module,
+						    LOGVIEW_TYPE_PLUGIN,
+						    "PipelogType",
+						    &info,
+						    0);
+		g_type_module_add_interface (module, type, LOGVIEW_TYPE_IFACE,
+					     &iface_info);
+		g_type_module_add_interface (module, type,
+					     LOGVIEW_TYPE_IFACE_IO, &io_info);
+	}
+	return type;
+}
+
+static void load_file (PluginPipelog* self)
+{
+	gint inc = 5*BUFSIZ, p =0, size = 0;
+
+	LV_MARK;
+	self->pbuffer = malloc (inc * sizeof (gchar) + 1);
+	while ((size = fread(self->pbuffer + p,
+			     sizeof (gchar),
+			     inc,
+			     self->file_handle)) == inc) {
+		p += inc;
+		self->pbuffer = realloc (self->pbuffer, p + inc + 1);
+	}
+	*(self->pbuffer + p + size) = '\0';
+	self->psize = p + size;
+}
+
+static gboolean
+plugin_init (PluginPipelog* self)
+{
+	gchar *utf8_name = NULL;
+	gchar *name;
+
+	LV_MARK;
+	self->file_handle = security_popen ((const char *)self->pipe, "r");
+	if (self->file_handle) {
+		load_file (self);
+		return update (self);
+	}
+
+	if (!self->log_name) {
+		/* SUN_BRANDING */
+		name = _("NULL Filename");
+	} else {
+		utf8_name = locale_to_utf8 (self->log_name);
+		name = utf8_name ? utf8_name : self->log_name;
+	}
+	/* SUN_BRANDING */
+	log_error_appendv ("pipelog - %s - %s", name, _("popen failed"));
+	g_free (utf8_name);
+	return FALSE;
+}
+
+static void
+plugin_destroy (PluginPipelog* self)
+{
+	LV_MARK;
+	if (self->file_handle != NULL) {
+		security_pclose (self->file_handle);
+	}
+	if (self->pipe)
+		g_free (self->pipe);
+	if (self->pbuffer)
+		g_free (self->pbuffer);
+}
+
+
+/* interfaces */
+static gboolean
+can_handle(PluginPipelog *self, Log *log)
+{
+	gchar *utf8_name = NULL;
+	gchar *name;
+	gchar *message = NULL;
+
+	LV_MARK;
+	g_object_get (G_OBJECT (log),
+		      "path", &self->log_name,
+		      "protocol", &self->protocol,
+		      NULL);
+
+	if (self->log_name == NULL) {
+		/* SUN_BRANDING */
+		log_error_appendv ("pipelog - %s", _("NULL Filename"));
+		return FALSE;
+	}
+	switch (self->protocol) {
+	case UNKNOWN_LOG:
+	case PLAIN_LOG:
+	case PIPE_LOG:
+		if (seek_pipe_log (self, self->log_name)) {
+			self->log = log;
+			self->protocol = PIPE_LOG;
+			g_object_set (G_OBJECT (log),
+				      "protocol", self->protocol,
+				      NULL);
+			return TRUE;
+		} else {
+			utf8_name = locale_to_utf8 (self->log_name);
+			name = (utf8_name) ? (utf8_name) : self->log_name;
+			/* SUN_BRANDING */
+			log_error_appendv ("pipelog - %s - %s", name, _("Cannot open"));
+			g_free (utf8_name);
+			return FALSE;
+		}
+	default:;
+	}
+	utf8_name = locale_to_utf8 (self->log_name);
+	name = (utf8_name) ? (utf8_name) : self->log_name;
+	/* SUN_BRANDING */
+	message = g_strdup_printf (_("Unknown file type: %d"), self->protocol);
+	log_error_appendv ("pipelog - %s - %s", name, message);
+	g_free (message);
+	g_free (utf8_name);
+	return FALSE;
+}
+
+static gboolean
+can_monitor(PluginPipelog *self)
+{
+	LV_MARK;
+	return FALSE;
+}
+
+static gboolean
+has_updated(PluginPipelog *self)
+{
+	LV_MARK;
+	return FALSE;
+}
+
+static gboolean
+update(PluginPipelog *self)
+{
+	struct stat buf;
+	LV_MARK;
+	g_assert (self->log_name != NULL);
+	if (stat (self->log_name, &buf) == 0) {
+		self->file_time = buf.st_mtime;
+		self->file_size = buf.st_size;
+	}
+	else {
+		LV_INFO_EE ("%s stat: %s", self->log_name,
+			    error_system_string());
+		self->file_time = 0;
+		self->file_size = 0;
+	}
+	return TRUE;
+}
+
+static size_t
+logf_read (PluginPipelog *self, void* buffer, size_t size)
+{
+	gssize lsize = 0;
+	LV_MARK;
+	g_assert (size >= 0 && buffer);
+	g_assert (self->psize >=0 && self->pbuffer);
+	g_assert (self->poffset >=0 && self->poffset <= self->psize);
+	lsize = self->psize - self->poffset;
+	if (size > lsize)
+		size = lsize;
+	bcopy (self->pbuffer, buffer, size * sizeof(gchar));
+	self->poffset += size;
+	return size;
+}
+
+static off_t
+logf_seek (PluginPipelog *self, off_t offset, int whence)
+{
+	g_assert (self->psize >=0 && self->pbuffer);
+	g_assert (self->poffset >=0 && self->poffset <= self->psize);
+	switch (whence) {
+	case SEEK_SET:
+		self->poffset = offset;
+		break;
+	case SEEK_CUR:
+		self->poffset += offset;
+		break;
+	case SEEK_END:
+		self->poffset = self->psize;
+		break;
+	default:
+		return -1;
+	}
+	return logf_tell(self);
+}
+
+static off_t
+logf_tell (PluginPipelog *self)
+{
+	g_assert (self->psize >=0 && self->pbuffer);
+	g_assert (self->poffset >=0 && self->poffset <= self->psize);
+	return (off_t)self->poffset;
+}
+
+static void
+logf_extract_filepath (PluginPipelog *self, gchar** dirname, gchar** filename)
+{
+	extract_filepath (self->log_name, dirname, filename);
+}
+
+static off_t
+get_size (PluginPipelog* self)
+{
+	return self->file_size;
+}
+
+static time_t
+get_modified_time (PluginPipelog* self)
+{
+	return self->file_time;
+}
+
+static void
+io_init (gpointer g_iface, gpointer iface_data)
+{
+	LogviewIFaceIO *iface = (LogviewIFaceIO*)g_iface;
+	LV_MARK;
+	iface->can_monitor = (gboolean (*) (LogviewIIO*)) can_monitor;
+	iface->extract_filepath = (void (*) (LogviewIIO*, gchar**, gchar**)) logf_extract_filepath;
+	iface->has_updated = (gboolean (*) (LogviewIIO*)) has_updated;
+	iface->update = (void (*) (LogviewIIO*)) update;
+	iface->read = (size_t (*) (LogviewIIO*, void*, size_t)) logf_read;
+	iface->seek = (off_t (*) (LogviewIIO*, off_t, int)) logf_seek;
+	iface->tell = (off_t (*) (LogviewIIO*)) logf_tell;
+	iface->get_size = (off_t (*) (LogviewIIO*)) get_size;
+	iface->get_modified_time = (time_t (*) (LogviewIIO*)) get_modified_time;
+}
+
+static void
+iface_init (gpointer g_iface, gpointer iface_data)
+{
+	LogviewInterface *iface = (LogviewInterface*)g_iface;
+	LV_MARK;
+	iface->can_handle = (gboolean (*) (LogviewIFace*, Log*)) can_handle;
+}
+
+static gboolean
+seek_pipe_log (PluginPipelog* self, const gchar *filename)
+{
+	GSList *plugin_paths, *i;
+	gboolean hint = FALSE;
+	gchar cbuf[BUFSIZ];
+	LV_MARK;
+
+	plugin_paths = (GSList *) get_plugin_paths ();
+
+	for (i = plugin_paths; !hint && i; i=g_slist_next(i)) {
+		gchar* path = g_build_path (G_DIR_SEPARATOR_S, i->data,
+					    PIPELOG_CONF, NULL);
+		if (local_file_exist (path)
+		    && local_file_can_executed (path)) {
+			FILE *handle = fopen (path, "r");
+			if (handle != NULL) {
+				while (!hint && fgets(cbuf, sizeof(cbuf), handle) != NULL) {
+					gchar *str, *fp;
+					g_strdelimit (cbuf, "\t\n", ' ');
+					str = g_strchug (cbuf);
+					if (g_str_has_prefix (str, "#"))
+						continue;
+					fp = g_strstr_len (str, strlen (str), filename);
+					if (fp != NULL) {
+						self->pipe = g_strdup_printf (
+							g_strstrip(fp + strlen (filename) + 1),
+							filename);
+						LV_INFO ("found pipe log : %s", self->pipe);
+						hint = TRUE;
+					}
+				}
+				fclose (handle);
+			}
+		}
+		g_free (path);
+	}
+	return hint;
+}
+
+LOGVIEW_INIT_PLUGIN (pipelog_get_type)
+
diff --git a/logview/plugins/pipelog.conf b/logview/plugins/pipelog.conf
new file mode 100644
index 0000000..fea6731
--- /dev/null
+++ b/logview/plugins/pipelog.conf
@@ -0,0 +1,2 @@
+/var/adm/wtmpx	last -f %s
+/var/adm/utmpx	last -f %s
